proc executeCommand {command room} {
  set url http://192.168.18.19:9002/status.html?$command&player=$room
  catch {
    exec /usr/local/addons/mc/wget $url -O /tmp/output.txt
  }
  return
}

proc isPlaying {room} {
  executeCommand "" $room
  set f [open "/tmp/output.txt"]
  set a [read $f]
  close $f
  set position "-1"
  regexp -indices "<b>Wiedergabe</b>" $a position
  if {$position == "-1"} {
    return "STOP"
  } else {
    return "PLAYING"
  }
}

proc getVolume {room} {
  executeCommand "" $room
  set f [open "/tmp/output.txt"]
  set a [read $f]
  close $f
  regexp "Lautstrke(.*)<b>(.*)</b>" $a dummy dummy actVolume
  return [expr {($actVolume - 1) * 10}]
}

proc setVolume {newVol room} {
  set volIsNum [string is integer -strict $newVol]
  if {$volIsNum == 1} {
    set setVol $newVol
    if {$setVol > 100} {set setVol 100}
    if {$setVol < 0} {set setVol 0}
    executeCommand "p0=mixer&p1=volume&p2=$setVol" $room
  }
}

proc waitEndAnnouncement {room} {
  set i 1
  while {$i < 60} {
    after 5000
    if {[isPlaying $room] == "STOP"} {break}
    set i [expr {$i + 1}]
  }
}

set room [lindex $argv 0]
set command [lindex $argv 1]
set command_arg1 [lindex $argv 2]
set command_arg2 [lindex $argv 3]
set command_arg3 [lindex $argv 4]
set command_arg4 [lindex $argv 5]
set command_arg5 [lindex $argv 6]

set processes [exec ps auxww | grep $room | egrep -v grep]
set stillExecuting -1
regexp -indices "\n" $processes stillExecuting
if {$stillExecuting > -1} {
  set PID [lindex $processes 0]
  exec kill $PID
}

switch $command {
  "DECREASE_VOL"
    {
      executeCommand "p0=mixer&p1=volume&p2=-$command_arg1" $room
    }
  "INCREASE_VOL"
    {
      executeCommand "p0=mixer&p1=volume&p2=+$command_arg1" $room
    }
  "SET_VOL"
    {
      setVolume $command_arg1 $room
    }
  "PLAY"
    {
      setVolume $command_arg2 $room
      executeCommand "p0=playlist&p1=play&p2=$command_arg1" $room
    }
  "STOP"
    {
      executeCommand "p0=playlist&p1=clear" $room
    }
  "TOGGLE_PLAY"
    {
      if {[isPlaying $room] == "STOP"} {
        setVol $command_arg2 $room
        executeCommand "p0=playlist&p1=play&p2=$command_arg1" $room
      } else {
        executeCommand "p0=playlist&p1=clear" $room
      }
    }
  "IS_PLAYING"
    {
      executeCommand "" $room
      puts "Is playing: [isPlaying]"
    }
  "GET_VOLUME"
    {
      puts "Volume is [getVolume $room]"
    }
  "MUTE"
    {
      setVolume 0 $room
    }
  "ANNOUNCEMENT"
    {
      set lastVolume [getVolume $room]
      set wasPlaying [expr {[string compare [isPlaying $room] "PLAYING"] == 0}]
      if {$wasPlaying && $command_arg1 == "CONTINUE"} {
        executeCommand "p0=playlist&p1=save&p2=LastPlaylist" $room
      }
      executeCommand "p0=playlist&p1=clear" $room
      setVolume $command_arg3 $room
      executeCommand "p0=playlist&p1=play&p2=$command_arg2" $room
      waitEndAnnouncement $room
      if {$command_arg1 == "PLAY" || ($command_arg1 == "TOGGLE_PLAY" && $wasPlaying == 0)} {
        setVolume $command_arg5 $room
        executeCommand "p0=playlist&p1=play&p2=$command_arg4" $room
      } else {
        setVolume $lastVolume $room
        if {$wasPlaying && $command_arg1 == "CONTINUE"} {
          executeCommand "p0=playlist&p1=resume&p2=LastPlaylist" $room
        } else {
          executeCommand "p0=playlist&p1=clear" $room
        }
      }
    }
}

